'$DYNAMIC
DECLARE SUB VSFadeToColor (r%, g%, b%, shades%)
DECLARE SUB VSFadeToPalette (file$, shades%)
DECLARE SUB VSFont (segment%, offset%, x%, y%, text$, col1%, col2%)
DECLARE SUB VSGrayScale
DECLARE SUB VSPalette (palfile$)
DECLARE SUB VSShadowFont (segment%, offset%, x%, y%, text$, col1%, col2%, col3%, col4%)
DECLARE SUB VSSavePalette (palfile$)
DECLARE SUB VSFillPoly (BYVAL segment%, BYVAL offset%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL x3%, BYVAL y3%, BYVAL x4%, BYVAL y4%, BYVAL col%)
DECLARE SUB VSTexture (BYVAL segment1%, BYVAL offset1%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL x3%, BYVAL y3%, BYVAL x4%, BYVAL y4%, BYVAL segment2%, BYVAL offset2%, BYVAL flag%)
DECLARE SUB VSTri (BYVAL segment1%, BYVAL offset1%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL x3%, BYVAL y3%, BYVAL segment2%, BYVAL offset2%, BYVAL pixelVector%)
DECLARE sub VSWall (BYVAL segment1%, BYVAL offset1%, BYVAL x1%, BYVAL y1%, BYVAL y2%, BYVAL x2%, BYVAL y3%, BYVAL y4%, BYVAL segment2%, BYVAL offset2%)
DECLARE SUB VSBox (BYVAL segment%, BYVAL offset%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL col%)
DECLARE SUB VSLine (BYVAL segment%, BYVAL offset%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL col%)
DECLARE SUB VSXLine (BYVAL segment%, BYVAL offset%, BYVAL x1%, BYVAL x2%, BYVAL y%, BYVAL col%)
DECLARE SUB VSYLine (BYVAL segment%, BYVAL offset%, BYVAL x%, BYVAL y1%, BYVAL y2%, BYVAL col%)

DECLARE SUB VSFill (BYVAL segment%, BYVAL offset%, BYVAL col%)
DECLARE SUB VSPCopy (BYVAL segment1%, BYVAL offset%, BYVAL segment2%, BYVAL offset2%, BYVAL flag%)
DECLARE SUB VSScrollD (BYVAL segment%, BYVAL offset%, BYVAL y%)
DECLARE SUB VSScrollL (BYVAL segment%, BYVAL offset%, BYVAL x%)
DECLARE SUB VSScrollR (BYVAL segment%, BYVAL offset%, BYVAL x%)
DECLARE SUB VSScrollU (BYVAL segment%, BYVAL offset%, BYVAL y%)

DECLARE FUNCTION VSCollide% (BYVAL segment1%, BYVAL offset1%, BYVAL x%, BYVAL y%, BYVAL segment2%, BYVAL offset2%)
DECLARE FUNCTION VSCollide2% (BYVAL segment1%, BYVAL offset1%, BYVAL x%, BYVAL y%, BYVAL col%, BYVAL segment2%, BYVAL offset2%)
DECLARE SUB VSGet (BYVAL segment1%, BYVAL offset1%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL segment2%, BYVAL offset2%)
DECLARE SUB VSPut (BYVAL segment1%, BYVAL offset1%, BYVAL x%, BYVAL y%, BYVAL segment2%, BYVAL offset2%)
DECLARE SUB VSPutT (BYVAL segment1%, BYVAL offset1%, BYVAL x%, BYVAL y%, BYVAL segment2%, BYVAL offset2%)
DECLARE SUB VSSprite (BYVAL segment1%, BYVAL offset1%, BYVAL x%, BYVAL y%, BYVAL segment2%, BYVAL offset2%, BYVAL flag%)
DECLARE SUB VSSpriteC (BYVAL segment1%, BYVAL offset1%, BYVAL x%, BYVAL y%, BYVAL col%, BYVAL segment2%, BYVAL offset2%)
DECLARE SUB VSSpriteR (BYVAL segment1%, BYVAL offset1%, BYVAL x%, BYVAL y%, BYVAL cosval%, BYVAL sinval%, BYVAL segment2%, BYVAL offset2%)
DECLARE SUB VSSpriteS (BYVAL segment1%, BYVAL offset1%, BYVAL x%, BYVAL y%, BYVAL sx%, BYVAL sy%, BYVAL segment2%, BYVAL offset2%)
' 
'                        RTEngine include file v1.0
'                        by Enhanced Creations 1999
' 

DEFINT A-Z
'$DYNAMIC

' 
' Function prototypes
' 

' Inits RTE
DECLARE FUNCTION RTEinit% (BYVAL NumTextures%, BYVAL XMSneeded%)
' Shuts down RTE
DECLARE SUB RTEclose ()
' Calculates and draws a frame, given player position, angle, doors and objects
DECLARE SUB RTEdoFrame (BYVAL BufferSeg%, BYVAL x%, BYVAL y%, BYVAL Angle%, BYVAL DoorSeg%, BYVAL ObjSeg%)
' Waits for vertical retrace and copies contents of buffer to the screen
DECLARE SUB RTEtoScreen (BYVAL BufferSeg%)
' Scales and copies contents of buffer to the a box on the screen
DECLARE SUB RTEtoBox (BYVAL BufferSeg%, BYVAL x%, BYVAL y%)
' Stores sprite into XMS, at specified position
DECLARE SUB RTEstoreSprite (BYVAL SpriteSeg%, BYVAL IdNumber%)
' Stores level texture into base memory, at specified position
DECLARE SUB RTEstoreTexture (BYVAL TextureSeg%, BYVAL IdNumber%)
' Loads a level map in memory and initializes doors
DECLARE SUB RTEloadMap (BYVAL MapSeg%, BYVAL DoorSeg%, BYVAL ObjectSeg%)
' Returns true if specified key is currently pressed
DECLARE FUNCTION RTEkey% (BYVAL ScanCode%)
' Sets various engine option flags
DECLARE SUB RTEsetOptions (BYVAL OptionsSeg%, BYVAL OptionsOff%)
' Builds the light color map, with colors fading to FarColor% with distance
DECLARE SUB RTEbuildLightMap (BYVAL PalSeg%, BYVAL FarColor%)
' Finds into palette the color that best fits with specified hues
DECLARE FUNCTION RTEfindCol% (BYVAL PalSeg%, BYVAL Red%, BYVAL Green%, BYVAL Blue%)
' Returns id of the door in front of player, 0 if no doors
DECLARE FUNCTION RTEfindDoor% (BYVAL x%, BYVAL y%, BYVAL Angle%)
' Opens a specified door, and sets the "still" time delay before closing
DECLARE SUB RTEopenDoor (BYVAL DoorId%, BYVAL Delay%, BYVAL DoorSeg%)
' Updates doors on current level
DECLARE SUB RTEupdateDoors (BYVAL x%, BYVAL y%, BYVAL DoorSeg%, BYVAL ObjSeg%)
' Returns specified map block informations
DECLARE SUB RTEgetMap (BYVAL x%, BYVAL y%, Wall%, Floor%, Ceiling%)
' Sets specified map block informations
DECLARE SUB RTEsetMap (BYVAL x%, BYVAL y%, BYVAL Wall%, BYVAL Floor%, BYVAL Ceiling%)
' Moves object from a point to another one, checking for collisions
DECLARE SUB RTEwalk (x%, y%, BYVAL DestX%, BYVAL DestY%, BYVAL DoorSeg%, BYVAL ObjSeg%)
' Finds the angle between two given points (in the range 0-1919)
DECLARE FUNCTION RTEangle% (BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%)
' Draws player level map
DECLARE SUB RTEdrawMap (BYVAL VideoSeg%, BYVAL x%, BYVAL y%)
' Draws a console box
DECLARE SUB RTEconsole (BYVAL VideoSeg%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%)
' Font drawing
DECLARE SUB RTEprint (BYVAL VideoSeg%, BYVAL x%, BYVAL y%, BYVAL StrSeg%, BYVAL StrOff%, BYVAL Col%)
' Font setting
DECLARE SUB RTEsetFont (BYVAL FontSeg%, BYVAL FontOff%)
' Sets new sky picture
DECLARE SUB RTEsetSky (BYVAL SkySeg%, BYVAL SkyOff%)
' Initializes the mouse
DECLARE FUNCTION RTEmouseInit% ()
' Returns mouse x position
DECLARE FUNCTION RTEmouseX% ()
' Returns mouse y position
DECLARE FUNCTION RTEmouseY% ()
' Returns true if left mouse button is pressed
DECLARE FUNCTION RTEmouseLB% ()
' Returns true if right mouse button is pressed
DECLARE FUNCTION RTEmouseRB% ()
' Shows mouse cursor
DECLARE SUB RTEmouseShow ()
' Hides mouse cursor
DECLARE SUB RTEmouseHide ()
' Sets new mouse position
DECLARE SUB RTEsetMousePos (BYVAL NewX%, BYVAL NewY%)
' Sets new mouse shape and hotspot position
DECLARE SUB RTEsetMouseShape (BYVAL ShapeSeg%, BYVAL ShapeOff%, BYVAL HotX%, BYVAL HotY%)
' Draws a sprite from XMS
DECLARE SUB RTEput (BYVAL VideoSeg%, BYVAL SpriteNum%, BYVAL x%, BYVAL y%, BYVAL Scale%)
' Sets view height
DECLARE SUB RTEsetViewHeight (BYVAL ViewHeight%)
' Sets plane height
DECLARE SUB RTEsetPlayerHeight (BYVAL PlayerHeight%)

' 
' Predefined data types
' 

' Customizable engine settings
TYPE RTEsettings
  Detail AS INTEGER           ' Graphical detail flags
  FloorColor AS INTEGER       ' Floor filling color when textures are off
  CeilingColor AS INTEGER     ' Ceiling filling color when textures are off
  MapBackColor AS INTEGER     ' Player's map background color
  MapWallColor AS INTEGER     ' Player's map walls color
  MapDoorColor AS INTEGER     ' Player's map doors color
  MapVisitedColor AS INTEGER  ' Player's map visited path color
  Sight AS INTEGER            ' Sight level (when light-shading is on)
  ClipX1 AS INTEGER           ' Upper-left corner x coord. of clipping box
  ClipY1 AS INTEGER           ' Upper-left corner y coord. of clipping box
  ClipX2 AS INTEGER           ' Lower-right corner x coord. of clipping box
  ClipY2 AS INTEGER           ' Lower-right corner y coord. of clipping box
END TYPE

' Doors structure (must remain 8 bytes!)
TYPE RTEdoor
  offset AS STRING * 1        ' Ranges 0-63; 0=door opened, 63=door closed
  status AS STRING * 1        ' 0=closed, 1=opening, 2=still, 3=closing
  Delay AS INTEGER            ' Cycles the door will remain opened, -1=forever
  xmap AS STRING * 1          ' x cell position on map (ranges 0-63)
  ymap AS STRING * 1          ' y cell position on map (ranges 0-63)
  Texture AS STRING * 1       ' Texture number
  available AS STRING * 1     ' 1 padding byte
END TYPE

' Objects structure (must remain 16 bytes!)
TYPE RTEobject
  Texture AS INTEGER          ' Texture number
  x AS INTEGER                ' x absolute position on map (ranges 0-4095)
  y AS INTEGER                ' y absolute position on map (ranges 0-4095)
  ang AS INTEGER              ' Absolute angle of object (ranges 0-1919)
  flags AS INTEGER            ' Various object option bits
  available AS STRING * 6     ' THE 6 BYTES HERE CAN BE USED AS YOU WISH
END TYPE

' 
' Engine constants
' 

CONST KEYESC = 1, KEYENTER = 28, KEYSPACE = 57
CONST KEYUP = 72, KEYDOWN = 80, KEYLEFT = 75, KEYRIGHT = 77
CONST Floor = 1, Ceiling = 2, VSYNC = 4, SHADING = 8, SKY = 16

'----------------------------------------------------------------------------
' DIRECTQB.BI
'   Include file for the DirectQB library version 1.61
'   by Angelo Mottola - Enhanced Creations 1998-99
'
' This file contains constants and function declarations used by the library
' Always include this file into your own programs!
'
' Include file created on 07-31-2000 by the DirectQB Library Manager v1.2
' Run DQBMAN again to modify your DirectQB module settings
'
'  Read DIRECTQB.DOC for detailed informations on how to use the library
'----------------------------------------------------------------------------

'$DYNAMIC
DEFINT A-Z

' Procedures from MAIN.OBJ:
DECLARE FUNCTION DQBinit% (BYVAL NumLayers%, BYVAL NumSounds%, BYVAL MemSize%)
DECLARE FUNCTION DQBver% ()
DECLARE FUNCTION DQBid$ ()
DECLARE FUNCTION DQBmapLayer% (BYVAL Layer%)
DECLARE SUB DQBclose ()
DECLARE SUB DQBpeek (BYVAL DataSeg%, BYVAL DataOff%, BYVAL Offset&, BYVAL Length%)
DECLARE SUB DQBpoke (BYVAL DataSeg%, BYVAL DataOff%, BYVAL Offset&, BYVAL Length%)
DECLARE SUB DQBsort (BYVAL ArraySeg%, BYVAL ArrayOff%, BYVAL NumRecords%, BYVAL RecordLen%, BYVAL IndexOff%)
DECLARE FUNCTION DQBangle% (BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%)
DECLARE SUB DQBinitVGA ()
DECLARE SUB DQBinitText ()
DECLARE FUNCTION DQBsetBaseLayer% (BYVAL Layer%)
DECLARE SUB DQBcopyLayer (BYVAL SourceLayer%, BYVAL DestLayer%)
DECLARE SUB DQBclearLayer (BYVAL Layer%)
DECLARE SUB DQBwait (BYVAL Times%)
DECLARE SUB DQBsetFrameRate (BYVAL FPS%)
DECLARE FUNCTION DQBframeReady% ()
DECLARE FUNCTION DQBerror$ ()

' Procedures from DRAW.OBJ:
DECLARE SUB DQBcopyTransLayer (BYVAL SourceLayer%, BYVAL DestLayer%)
DECLARE SUB DQBcopyHitLayer (BYVAL SourceLayer%, BYVAL DestLayer%, BYVAL Col%)
DECLARE SUB DQBpset (BYVAL Layer%, BYVAL x%, BYVAL y%, BYVAL Col%)
DECLARE FUNCTION DQBpoint% (BYVAL Layer%, BYVAL x%, BYVAL y%)
DECLARE SUB DQBline (BYVAL Layer%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL Col%)
DECLARE SUB DQBgline (BYVAL Layer%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL Col1%, BYVAL Col2%)
DECLARE SUB DQBellipse (BYVAL Layer%, BYVAL x%, BYVAL y%, BYVAL rx%, BYVAL ry%, BYVAL Col%)
DECLARE SUB DQBbox (BYVAL Layer%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL Col%)
DECLARE SUB DQBboxf (BYVAL Layer%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL Col%)
DECLARE SUB DQBpaint (BYVAL Layer%, BYVAL x%, BYVAL y%, BYVAL Col%)
DECLARE SUB DQBscroll (BYVAL Layer%, BYVAL dx%, BYVAL dy%)
DECLARE SUB DQBscrollArea (BYVAL Layer%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL Direction%)
DECLARE SUB DQBsetTransPut ()
DECLARE SUB DQBsetSolidPut ()
DECLARE SUB DQBget (BYVAL Layer%, BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2%, BYVAL BufSeg%, BYVAL BufOff%)
DECLARE SUB DQBput (BYVAL Layer%, BYVAL x%, BYVAL y%, BYVAL BufSeg%, BYVAL BufOff%)

' Procedures from IMAGE.OBJ:
DECLARE FUNCTION DQBloadImage% (Layer%, x%, y%, FileName$, Pal$, imgWidth%, imgHeight%)
DECLARE FUNCTION DQBsaveImage% (Layer%, x1%, y1%, x2%, y2%, FileName$, Pal$, Format%)
DECLARE FUNCTION DQBplayFLI% (FileName$, BufLayer%, KeyStop%, LoopFlag%)
DECLARE FUNCTION DQBopenFLI% (FileName$, Frames%, Speed%)
DECLARE SUB DQBplayFLIstep (BYVAL Layer%)
DECLARE SUB DQBcloseFLI ()

' Procedures from SOUND.OBJ:
DECLARE FUNCTION DQBinstallSB% (BYVAL VolActive%, BYVAL Channels%, BYVAL Freq%, BYVAL BaseAddr%, BYVAL IRQ%, BYVAL DMA%)
DECLARE FUNCTION DQBloadSound% (Slot%, FileName$)
DECLARE FUNCTION DQBloadRawSound% (Slot%, FileName$, Offset&, Length&)
DECLARE FUNCTION DQBinUse% (BYVAL Voice%)
DECLARE SUB DQBplaySound (BYVAL SoundNum%, BYVAL Voice%, BYVAL Freq%, BYVAL LoopFlag%)
DECLARE SUB DQBsetVoiceVol (BYVAL Voice%, BYVAL NewVol%)
DECLARE SUB DQBpauseSound ()
DECLARE SUB DQBresumeSound ()
DECLARE SUB DQBstopVoice (BYVAL Voice%)
DECLARE SUB DQBremoveSB ()
DECLARE SUB DQBsetVolume (BYVAL Volume%)

' Library constants:
CONST FALSE = 0, TRUE = NOT FALSE
CONST B0 = &H8000, B1 = &H8001, B2 = &H8002, B3 = &H8003, B4 = &H8004
CONST B5 = &H8005, B6 = &H8006, B7 = &H8007, B8 = &H8008, B9 = &H8009
CONST BSV = 0, BMP = 1, PCX = 2
CONST UP = 0, DOWN = 1, LEFT = 2, RIGHT = 3
CONST AUTO = -1, ONCE = 0, LOOPED = 1
